
#include <string>
#include <vector>

#pragma once

using namespace std;


class CVSFS
{

public:
  string  m_dir;
  bool    is_cvsdir;

  int     m_start_mode;
  string  m_cvs_root;


  char    m_title[256];

  FILE*   m_logfile;

  CVSFS(const string& dir="",int start_mode=2)
  : is_cvsdir(false),m_start_mode(start_mode),m_cvs_root(""),m_logfile(0)
  {
    ChangeDir(dir);
    //string logname=getenv("TEMP");
    //logname+="\\cvs.log";
    //logfile=fopen(logname.c_str(),"wt");
  };

  void Log(const char* str)
  {
    if(m_logfile)
    {
      if(str)fputs(str,m_logfile);
      fputs("\n",m_logfile);
      fflush(m_logfile);
    };
  };

  void Log(const char* str,int number)
  {
    if(m_logfile)
    {
      fprintf(m_logfile,"%s%d\n",str?str:"",number);
      fflush(m_logfile);
    };
  };

  virtual ~CVSFS()
  {

    if(m_logfile)
      fclose(m_logfile);
  };

  void ChangeDir(const string& _dir);
  void FillInfoStruct(OpenPluginInfo *out_pInfo);


};

//  
bool View();
bool PasteName();